﻿


'*******************************************************************
' Program: Data Center Visio Rack Tool
' Author: Albert E Edlund
' Date:
'
' Purpose:
'
'
'
'*******************************************************************


Imports Microsoft.Practices.EnterpriseLibrary.Common
Imports Microsoft.Practices.EnterpriseLibrary.Data
Imports Microsoft.Practices.EnterpriseLibrary.ExceptionHandling
Imports Microsoft.Practices.EnterpriseLibrary.ExceptionHandling.Logging

Imports System
Imports System.ComponentModel
Imports System.Collections.Generic


Public Class dc_AppConn
    Implements INotifyPropertyChanged


#Region "Events"

    Public Event PropertyChanged(ByVal sender As Object, ByVal e As System.ComponentModel.PropertyChangedEventArgs) Implements System.ComponentModel.INotifyPropertyChanged.PropertyChanged

    Private Sub OnPropertyChanged(ByVal info As String)
        RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(info))
    End Sub

#End Region

#Region " Constructor "

    Public Sub New()
        initProperties()
    End Sub

    Public Sub New(ByVal strUserId As String)
        initProperties()
        Me.m_appconLastEdit = strUserId
    End Sub

#End Region

#Region " Properties and Fields "


    Private m_appconKey As Int32
    Public Const constAppConKey As Int32 = -1
    Public Property appconKey() As Int32
        Get
            Return Me.m_appconKey
        End Get
        Set(ByVal value As Int32)
            Me.m_appconKey = value
            Me.OnPropertyChanged("appconKey")
        End Set
    End Property

    '****************************************************
    ' add the rest
    '****************************************************

    ' the parent solution
    Private m_appconSolKey As Int32
    Public Const constAppConSolKey As Int32 = -1
    Public Property appconSolKey() As Int32
        Get
            Return Me.m_appconSolKey
        End Get
        Set(ByVal value As Int32)
            Me.m_appconSolKey = value
            Me.OnPropertyChanged("appconSolKey")
        End Set
    End Property

    Private m_appconAppAKey As Int32
    Public Const constAppConAppAKey As Int32 = -1
    Public Property appconAppAKey() As Int32
        Get
            Return Me.m_appconAppAKey
        End Get
        Set(ByVal value As Int32)
            Me.m_appconAppAKey = value
            Me.OnPropertyChanged("appconAppAKey")
        End Set
    End Property

    Private m_appconAppBKey As Int32
    Public Const constAppConAppBKey As Int32 = -1
    Public Property appconAppBKey() As Int32
        Get
            Return Me.m_appconAppBKey
        End Get
        Set(ByVal value As Int32)
            Me.m_appconAppBKey = value
            Me.OnPropertyChanged("appconAppBKey")
        End Set
    End Property

    '****************************************************
    ' finish
    '****************************************************

    Private m_appconComments As String
    Public Const constAppConComments As String = "na"
    Public Property appconComments() As String
        Get
            Return Me.m_appconComments
        End Get
        Set(ByVal value As String)
            Me.m_appconComments = value
            Me.OnPropertyChanged("appconComments")
        End Set
    End Property

    Private m_appconlastUpdate As Date
    Public Const constAppconLastUpdate As Date = #1/1/2001#
    Public Property appconLastUpdate() As Date
        Get
            Return Me.m_appconlastUpdate
        End Get
        Set(ByVal value As Date)
            Me.m_appconlastUpdate = value
            Me.OnPropertyChanged("appconLastUpdate")
        End Set
    End Property

    Private m_appconLastEdit As String
    Public Const constAppconLastEdit As String = ""
    Public Property appconLastEdit() As String
        Get
            Return Me.m_appconLastEdit
        End Get
        Set(ByVal value As String)
            Me.m_appconLastEdit = value
            Me.OnPropertyChanged("appconLastEdit")
        End Set
    End Property

#End Region

#Region " Methods "


    Public Sub initProperties()

        Try
            appconKey = constAppConKey

            '******************************************

            appconSolKey = constAppConSolKey
            appconAppAKey = constAppConAppAKey
            appconAppBKey = constAppConAppBKey

            '******************************************
            appconComments = constAppConComments
            appconLastUpdate = Now
            appconLastEdit = constAppconLastEdit

        Catch ex As Exception
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(ex, "Log Only Policy")
            If (rethrow) Then
                Throw
            End If
        End Try

    End Sub




#End Region


End Class


