﻿


'*******************************************************************
' Program: Data Center Visio Rack Tool
' Author: Albert E Edlund
' Date:
'
' Purpose:
'
'
'
'*******************************************************************


Imports Microsoft.Practices.EnterpriseLibrary.Common
Imports Microsoft.Practices.EnterpriseLibrary.Data
Imports Microsoft.Practices.EnterpriseLibrary.ExceptionHandling
Imports Microsoft.Practices.EnterpriseLibrary.ExceptionHandling.Logging

Imports System
Imports System.ComponentModel
Imports System.Collections.Generic


Public Class dc_AppSol
    Implements INotifyPropertyChanged


#Region "Events"

    Public Event PropertyChanged(ByVal sender As Object, ByVal e As System.ComponentModel.PropertyChangedEventArgs) Implements System.ComponentModel.INotifyPropertyChanged.PropertyChanged

    Private Sub OnPropertyChanged(ByVal info As String)
        RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(info))
    End Sub

#End Region

#Region " Constructor "

    Public Sub New()
        initProperties()
    End Sub

    Public Sub New(ByVal strUserId As String)
        initProperties()
        Me.m_appsolLastEdit = strUserId
    End Sub

#End Region

#Region " Properties and Fields "


    Private m_appsolKey As Int32
    Public Const constappsolKey As Int32 = -1
    Public Property appsolKey() As Int32
        Get
            Return Me.m_appsolKey
        End Get
        Set(ByVal value As Int32)
            Me.m_appsolKey = value
            Me.OnPropertyChanged("appsolKey")
        End Set
    End Property

    Private m_appsolClientKey As Int32
    Public Const constappsolClientKey As Int32 = -1
    Public Property appsolClientKey() As Int32
        Get
            Return Me.m_appsolClientKey
        End Get
        Set(ByVal value As Int32)
            Me.m_appsolClientKey = value
            Me.OnPropertyChanged("appsolClientKey")
        End Set
    End Property



    '****************************************************
    ' add the rest
    '****************************************************

    Private m_appsolName As String
    Public Const constAppSolName As String = "na"
    Public Property appsolName() As String
        Get
            Return Me.m_appsolName
        End Get
        Set(ByVal value As String)
            Me.m_appsolName = value
            Me.OnPropertyChanged("appsolName")
        End Set
    End Property

    '****************************************************
    ' finish
    '****************************************************

    Private m_appsolComments As String
    Public Const constappsolComments As String = "na"
    Public Property appsolComments() As String
        Get
            Return Me.m_appsolComments
        End Get
        Set(ByVal value As String)
            Me.m_appsolComments = value
            Me.OnPropertyChanged("appsolComments")
        End Set
    End Property

    Private m_appsollastUpdate As Date
    Public Const constappsolLastUpdate As Date = #1/1/2001#
    Public Property appsolLastUpdate() As Date
        Get
            Return Me.m_appsollastUpdate
        End Get
        Set(ByVal value As Date)
            Me.m_appsollastUpdate = value
            Me.OnPropertyChanged("appsolLastUpdate")
        End Set
    End Property

    Private m_appsolLastEdit As String
    Public Const constappsolLastEdit As String = ""
    Public Property appsolLastEdit() As String
        Get
            Return Me.m_appsolLastEdit
        End Get
        Set(ByVal value As String)
            Me.m_appsolLastEdit = value
            Me.OnPropertyChanged("appsolLastEdit")
        End Set
    End Property

#End Region

#Region " Methods "


    Public Sub initProperties()

        Try
            appsolKey = constappsolKey
            appsolClientKey = constappsolClientKey
            '******************************************
            appsolName = constAppSolName
            '******************************************
            appsolComments = constappsolComments
            appsolLastUpdate = Now
            appsolLastEdit = constappsolLastEdit

        Catch ex As Exception
            Dim rethrow As Boolean = ExceptionPolicy.HandleException(ex, "Log Only Policy")
            If (rethrow) Then
                Throw
            End If
        End Try

    End Sub




#End Region


End Class


